//// font size
var fontSize = function() {
  var elements = ['h1', 'h2', 'h3', 'h4', 'h5', 'h6', '.btn'],
      elements_length = elements.length,
      elements_size = {};

  // get elements size with jquery after document ready
  $(document).ready(function() {
    for (var i = 0; i < elements_length; i++) {
      elements_size[elements[i]] = $(elements[i]).css('fontSize');
    }
  });

  // init
  size_c = readCookie('fontSize');
  if (size_c != null) {
    $(document).ready(function() {
      reloadFontSize(size_c);
    });
  }
  else {
    createCookie('fontSize', 0, 365);
  }

  function reloadFontSize(size) {
    var i = 0;
    size = (parseFloat(size) / 10) + 1;

    // change body font size
    $('body').css('fontSize', (size * 100) + '%', 'important');

    // change custom elements
    for (i; i < elements_length; i++) {
      $(elements[i]).css('fontSize', (parseFloat(elements_size[elements[i]]) * size) + "px", 'important');
    }
  }

  return {
    resizeText: function(increment) {
      var size = parseFloat(readCookie('fontSize'));
      increment = parseFloat(increment);

      if (increment === 0) size = 0;
      else if (((size > -6) && (increment < 0)) || ((size < 7) && (increment > 0))) {
        size = size + increment;
      };
      reloadFontSize(size);

      createCookie('fontSize', size, 365);
    }
  };
}

//// contrast
var contrast = function() {
  var contrast_elements = 'body, .barra-brasil, .search-bar, .learning-object-vertical .panel, .navbar, .well';

  // init
  $(document).ready(function() {
    run();
  });

  function run() {
    var contrast_c = readCookie('contrast');

    if (contrast_c == null || contrast_c != "true") {
      $(contrast_elements).removeClass('contraste');
      $('.search-bar').css('border-top','none');
      $('#menu-bar').removeClass('menu-bar-contrast');
    }
    else {
      $(contrast_elements).addClass('contraste');
      $('.search-bar').css('border-top','2px solid white');
      $('#menu-bar').addClass('menu-bar-contrast');
    }
  }

  return {
    change: function() {
      (readCookie('contrast') == "true") ? createCookie('contrast',"false",0) : createCookie('contrast',"true",0);
      run();
    }
  };
}

//// cookies
//source: http://www.linhadecodigo.com.br/artigo/1615/acessibilidade-aumentando-e-diminuindo-tamanho-de-letra-em-seu-site.aspx
function createCookie(name,value,days) {
	if (days) {
		var date = new Date();
		date.setTime(date.getTime()+(days*24*60*60*1000));
		var expires = "; expires="+date.toGMTString();
	} else var expires = "";
	document.cookie = name+"="+value+expires+"; path=/";
}

function readCookie(name) {
	var nameEQ = name + "=";
	var ca = document.cookie.split(";");
	for (var i=0;i < ca.length;i++)	{
		var c = ca[i];
		while (c.charAt(0)==" ") c = c.substring(1,c.length);
		if (c.indexOf(nameEQ) == 0) return c.substring(nameEQ.length,c.length);
	}
	return null;
}

// define global variables
var fontSize = fontSize();
var contrast = contrast();
