class Collection
  include ActiveModel::Model
  attr_accessor :id, :created_at, :description, :name, :views, :likes,
                :owner, :learning_objects
  validates_presence_of :name, :created_at, :views, :likes, :owner, :learning_objects
  validates_with Validators::CollectionOwnerValidator

  def initialize(params={})
    super(params.merge(defaults))
  end

  private

  def defaults
    {
        views: 0,
        likes: 0,
        created_at: DateTime.new,
        owner: User.new,
        learning_objects: []
    }
  end

end
