##
# This class keep all migrations of orient db and execute them.
class OrientDb::Migrations
  attr_accessor :migrations

  def initialize(client)
    @migrations = []
    # Vertices
    @migrations << CreateUser.new(client)
    @migrations << CreateAttribute.new(client)
    @migrations << CreateComment.new(client)
    @migrations << CreateObject.new(client)
    # Vertices inheriting from Object
    @migrations << CreateInstitution.new(client)
    @migrations << CreateLearningObject.new(client)
    # Vertices inheriting from LearningObject
    @migrations << CreateCollection.new(client)
    @migrations << CreateSubject.new(client)
    @migrations << CreateMainPage.new(client)

    # Edges
    @migrations << CreateIsAbout.new(client)
    @migrations << CreatePublishedBy.new(client)
    @migrations << CreateBelongsTo.new(client)
    @migrations << CreateLike.new(client)
    @migrations << CreateHasAttr.new(client)
    @migrations << CreateComments.new(client)
    @migrations << CreateCommentedBy.new(client)
  end

  ##
  # Execute all migrations
  def run
    @migrations.each { |m| m.up }
  end

  def drop
    @migrations.reverse_each { |m| m.down }
  end
end