class OrientDb::Migrations::CreateAttribute < OrientDb::Migration

  def up
    create_class 'Attribute', 'V' do |c|
        c.property 'key', :string
        c.property 'value', :string
    end
    add_index 'Attribute', ['key'], "NOTUNIQUE_HASH_INDEX"
    metadata = {:analyzer => "org.apache.lucene.analysis.br.BrazilianAnalyzer"}
    add_index 'Attribute', ['value'], "FULLTEXT", nil, "LUCENE", metadata.to_json
  end

  def down
    drop_class 'Attribute'
  end
end