namespace :thumbnail do

  desc "Generate Thumbnails"
  task :generate => :environment do

    include RepositoriesProxy

    # Quantity of items fetched on each iteration
    limit = 500

    # Start point from where items will be fetched
    offset = 0

    loop do

      begin
        # Get items from dspace (from offset to offset+limit)
        items = learning_object_repository.all_from_offset_to_limit(offset,limit)
      rescue
        # Sleeps for a while to wait database's recovery
        sleep(30.seconds)
        # Goes to next iteration to retry
        next
      else
        # Terminate loop if there are no more items to import
        break if items.empty?

        # Increment offset, to get new items on next iteration
        offset = offset + limit

        items.each do |item|
          ThumbnailGeneratorWorker.perform_async(item.id)
        end

      end
    end
  end

end
